# IO Engage Integration

## What is it?

Basic implementation for keeping delegate records up to date with IO Engage and update meeting attendance 

## Configuration

You will need to publish the ioengage config through the vendor:publish command. All publishable items are tagged with `ioengage-integration`

### Environment Keys
```
IOENGAGE_CLIENT_ID=CLIENT_ID
IOENGAGE_CLIENT_SECRET=CLIENT_SECRET 
# This shouldn't need to be changed but it's configurable just in case
IOENGAGE_GRANT_TYPE=CLIENT_CREDENTIALS

IOENGAGE_TOKEN_ENDPOINT=https://example.com/token
IOENGAGE_DELEGATE_ENDPOINT=https://example.com/delegate
IOENGAGE_SEARCH_ENDPOINT=https://example.com/search
IOENGAGE_MEETING_ENDPOINT=https://example.com/meeting
```

## Usage

### Search
```php
use Drp\IOEngage\Facades\IOEngage;

$results = IOEngage::search([
    'first_name' => 'Kevin',
    'city' => 'Scranton',
]);
```

#### Available Parameters

These fields are searched via `LIKE`.

* `identifier`
* `first_name`
* `last_name`
* `company`
* `city`

These fields are searched via exact values.

* `name`
* `email`
* `job_title`
* `line_1`
* `line_2`
* `country`
* `postcode`
