<?php

namespace Drp\IOEngage;

use Drp\IOEngage\Resources\Delegate;
use Drp\IOEngage\Resources\InvalidDelegate;
use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Arr;

class DelegatesResults implements Arrayable
{
    /** @var int */
    public $validCount = 0;

    /** @var int */
    public $invalidCount = 0;

    /** @var \Illuminate\Support\Collection */
    public $validDelegates;

    /** @var \Illuminate\Support\Collection */
    public $invalidDelegates;

    public function __construct(array $attributes)
    {
        $this->validCount = Arr::get($attributes, 'ValidRecordCount');
        $this->validDelegates = collect(Arr::get($attributes, 'ValidResults'))
            ->map(function (array $delegate) {
                return new Delegate($delegate);
            });

        $this->invalidCount = Arr::get($attributes, 'InvalidRecordCount');
        $this->invalidDelegates = collect(Arr::get($attributes, 'InvalidResults'))
            ->map(function ($response) {
                return new InvalidDelegate($response);
            });
    }

    public function toArray(): array
    {
        /** @var \Illuminate\Support\Collection $delegates */
        $delegates = $this->validDelegates->map->toArray();

        return [
            'count' => $this->validCount,
            'delegates' => $delegates->toArray(),
        ];
    }
}
