<?php

namespace Drp\IOEngage\Resources;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Support\Arr;

class Address implements Arrayable
{
    /** @var string|null */
    public $line1;

    /** @var string|null */
    public $line2;

    /** @var string|null */
    public $line3;

    /** @var string|null */
    public $city;

    /** @var string|null */
    public $areaCode;

    /** @var string|null */
    public $area;

    /** @var string|null */
    public $country;

    public function __construct(array $data)
    {
        $this->line1 = Arr::get($data, 'Line1');
        $this->line2 = Arr::get($data, 'Line2');
        $this->line3 = Arr::get($data, 'Line3');
        $this->city = Arr::get($data, 'City');
        $this->areaCode = Arr::get($data, 'PostCode');
        $this->area = Arr::get($data, 'County');
        $this->country = Arr::get($data, 'Country');
    }

    public static function fromArray(array $data): self
    {
        return new self($data);
    }

    public function toArray(): array
    {
        return [
            'line_1' => $this->line1,
            'line_2' => $this->line2,
            'line_3' => $this->line3,
            'city' => $this->city,
            'area_code' => $this->areaCode,
            'area' => $this->area,
            'country' => $this->country,
        ];
    }
}
