<?php

namespace Drp\IOEngage\Tests\Unit\Resources;

use Drp\IOEngage\Resources\Address;
use Drp\IOEngage\Tests\TestCase;

class AddressTest extends TestCase
{
    /** @test **/
    public function can_be_constructed()
    {
        $address = new Address([
            'Line1' => '212 Ikon Estate',
            'Line2' => 'Droitwich Road',
            'Line3' => 'Hartlebury',
            'City' => 'Kidderminster',
            'PostCode' => 'DY10 4EU',
            'County' => 'West Midlands',
            'Country' => 'United Kingdom',
        ]);

        $this->assertSame('212 Ikon Estate', $address->line1);
        $this->assertSame('Droitwich Road', $address->line2);
        $this->assertSame('Hartlebury', $address->line3);
        $this->assertSame('Kidderminster', $address->city);
        $this->assertSame('DY10 4EU', $address->areaCode);
        $this->assertSame('West Midlands', $address->area);
        $this->assertSame('United Kingdom', $address->country);
    }

    /** @test **/
    public function can_be_returned_as_array()
    {
        $address = new Address([
            'Line1' => '212 Ikon Estate',
            'Line2' => 'Droitwich Road',
            'Line3' => 'Hartlebury',
            'City' => 'Kidderminster',
            'PostCode' => 'DY10 4EU',
            'County' => 'West Midlands',
            'Country' => 'United Kingdom',
        ]);

        $expected = [
            'line_1' => '212 Ikon Estate',
            'line_2' => 'Droitwich Road',
            'line_3' => 'Hartlebury',
            'city' => 'Kidderminster',
            'area_code' => 'DY10 4EU',
            'area' => 'West Midlands',
            'country' => 'United Kingdom',
        ];

        $this->assertSame($expected, $address->toArray());
    }
}
